// another fine solution by misof
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <map>
using namespace std;

int R, S, P=1000000009, N, K;

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  scanf("%d%d%d",&R,&S,&N);
  while (N--) {
    vector< vector<int> > C(2, vector<int>(S+1,0) );
    scanf("%d",&K);
    multimap<int,int> M;
    multimap<int,int>::iterator it;
    for (int k=0; k<K; ++k) { 
      int x,y;
      scanf("%d%d",&x,&y);
      M.insert(make_pair(x,y));
    }
    for (int r=0; r<=R; ++r) {
      int r1=r&1, r2=1-r1;
      for (it=M.lower_bound(r); it!=M.upper_bound(r); ++it) C[r1][it->second]=-1;
      for (int s=0; s<=S; ++s)
        if (C[r1][s]==-1)
          C[r1][s]=0;
        else if (r==0 && s==0)
          C[r1][s] = 1;
        else if (r==0)
          C[r1][s] = C[r1][s-1];
        else if (s==0)
          C[r1][s] = C[r2][s];
        else {
          C[r1][s] = C[r2][s] + C[r1][s-1];
          if (C[r1][s] > P) C[r1][s] -= P;
        }
    }
    cout << C[R%2][S] << endl;
  }
}
