
const P : longint = 1000000009;
var R, S, N, Z, i, j, jj, dr, ds, nn: longint;
    prekazky : array[0..123,0..1] of longint;
    cesty : array[0..123] of int64;

    vstupy : array[0..1023,0..512,0..1] of longint;
    K : array[0..1023] of longint;
    data : array[0..1234567,0..2] of longint;
    comb: array[0..1,0..123456] of longint;

procedure swap(var a, b : longint);
var c : longint;
begin c:=a; a:=b; b:=c; end;

function C(a, b: longint) : longint;
var zac, kon, mid : longint;
begin
   if (a<0) or (b<0) then begin C:=0; exit; end;
   zac:=0; kon:=Z;
   while kon-zac>1 do begin
      mid:=(zac+kon) div 2;
      if data[mid][0] > a then begin kon:=mid; continue; end;
      if data[mid][0] < a then begin zac:=mid; continue; end;
      if data[mid][1] > b then begin kon:=mid; continue; end;
      zac := mid;
   end;
   C := data[zac][2];
end;

procedure store(rr, ss: longint);
begin data[Z][0]:=rr; data[Z][1]:=ss; inc(Z); end;

procedure precompute;
var rr, ss, zz, cur, prev : longint;
begin
   zz := 0;
   for rr:=0 to R do begin
      cur := rr mod 2;
      prev := 1 - cur;
      if s=0 then for ss:=0 to S do comb[cur][ss]:=1 else begin
         comb[cur][0]:=1;
         for ss:=1 to S do begin
            comb[cur][ss] := comb[prev][ss] + comb[cur][ss-1];
            if comb[cur][ss] > P then dec( comb[cur][ss], P );
         end;
      end;
      while data[zz][0]=rr do begin
         data[zz][2] := comb[ cur ][ data[zz][1] ];
         inc(zz);
      end;
   end;
end;

procedure qsort(l,r: longint);
var i,j,x0,x1: longint;
begin
   i:=l;
   j:=r;
   x0:=data[(l+r) div 2][0];
   x1:=data[(l+r) div 2][1];
   repeat
      while true do begin
         if data[i][0]>x0 then break;
         if (data[i][0]=x0) and (data[i][1]>=x1) then break;
         inc(i);
      end;
      while true do begin
         if x0>data[j][0] then break;
         if (x0=data[j][0]) and (x1>=data[j][1]) then break;
         dec(j);
      end;
      if not (i>j) then begin
         swap( data[i][0], data[j][0] );
         swap( data[i][1], data[j][1] );
         inc(i);
         dec(j);
      end;
   until i>j;
   if l<j then qsort(l,j);
   if i<r then qsort(i,r);
end;

procedure uniq;
var zz, last : longint;
begin
   last := 0;
   for zz := 1 to Z-1 do 
      if (data[zz][0]<>data[last][0]) or (data[zz][1]<>data[last][1]) then begin
         inc(last);
         swap( data[zz][0], data[last][0] );
         swap( data[zz][1], data[last][1] );
      end;
   Z := last + 1;
end;

begin
   close(input); assign(input, 'mravenci.in'); reset(input);
   close(output); assign(output, 'mravenci.out'); rewrite(output);
   { nacitame }
   read(R,S,N);
   for i:=0 to N-1 do begin
      read(K[i]);
      for j:=0 to K[i]-1 do read( vstupy[i][j][0], vstupy[i][j][1] );
   end;

   { zistime ktore kombinacne cisla treba }
   Z := 0;
   store(R,S);
   
   for i:=0 to N-1 do for j:=0 to K[i]-1 do store( vstupy[i][j][0], vstupy[i][j][1] );
   for i:=0 to N-1 do for j:=0 to K[i]-1 do store( R-vstupy[i][j][0], S-vstupy[i][j][1] );
   for i:=0 to N-1 do for j:=0 to K[i]-1 do
      for jj:=0 to K[i]-1 do if j<>jj then begin
         dr := vstupy[i][j][0] - vstupy[i][jj][0];
         ds := vstupy[i][j][1] - vstupy[i][jj][1];
         if (dr>=0) and (ds>=0) then store(dr,ds);
      end;
   store(R+1,S+1);

   { utriedime pole "data" }
   qsort(0,Z-1);
   uniq;

   { pocitame kombinacne cisla a pamatame si, ktore treba }
   precompute;

   { postupne spracuvame vstupy }
   for nn:=0 to N-1 do begin
      for i:=0 to K[nn]-1 do begin
         prekazky[i][0] := vstupy[nn][i][0];
         prekazky[i][1] := vstupy[nn][i][1];
      end;
      for i:=0 to K[nn]-1 do
         for j:=i+1 to K[nn]-1 do
            if prekazky[i][0]+prekazky[i][1] > prekazky[j][0]+prekazky[j][1] then begin
               swap( prekazky[i][0], prekazky[j][0] );
               swap( prekazky[i][1], prekazky[j][1] );
            end;

      prekazky[K[nn]][0]:=R; prekazky[K[nn]][1]:=S;
      for i:=0 to K[nn] do begin
         cesty[i] := C( prekazky[i][0], prekazky[i][1] );
         for j:=0 to i-1 do cesty[i] := ( cesty[i] - cesty[j] * C( prekazky[i][0]-prekazky[j][0], prekazky[i][1]-prekazky[j][1] ) ) mod P;
         cesty[i] := (cesty[i] + P) mod P;
      end;
      writeln( cesty[K[nn]] );
   end;
   close(input); close(output);
end.
